"use strict";
var filename = 'Normal.json';
var map = require('./' + filename);
var events = map._events;
var notes = map._notes;
var copyevents = {
	1: [],
	2: [],
	3: [],
	4: [],
	5: [],
	6: [],
	7: [],
	8: []
};
var copytimes = {
	1: 0,
	2: 0,
	3: 0,
	4: 0,
	5: 0,
	6: 0,
	7: 0,
	8: 0
};
var locations = [];
var mark = 0;
//copying events
for(var i = 0; i < events.length; i++)
{
		if(events[i]._type == 13)
		{
			if (events[i]._type !== 0)
			{
				if (copyevents[events[i]._value].length !== 0 && events[i]._value != mark)
				{
					locations.push({'type': events[i]._value, time: events[i]._time});
				}
				else
				{
					if (mark === 0)
					{
						mark = events[i]._value;
						copytimes[mark] = events[i]._time;
					}
					else
					{
						mark = 0;
					}
				}
			}
		}
		else
		{
			if (mark !== 0)
			{
				copyevents[mark].push(Object.assign({},events[i]));
			}
		}
}
//event normalization
for (var i = 1; i <= 8; i++)
{
	if (copyevents[i].length !== 0)
	{
		var normaltime = copytimes[i] //copyevents[i][0]._time;
		for (var j = 0; j < copyevents[i].length; j ++)
		{
			copyevents[i][j]._time = copyevents[i][j]._time - normaltime;
		}
	}
}
//event pasting

for (var i = 0; i < locations.length; i++)
{
	for (var j = 0; j < copyevents[locations[i].type].length; j ++)
	{
		var newEvent = Object.assign({},copyevents[locations[i].type][j]);
		newEvent._time += locations[i].time;
		map._events.push(newEvent);
	}
	
}
//sort events
events.sort(function(a,b){
	return a._time - b._time;
});

//write to file
var jsonData = JSON.stringify(map);
var fs = require('fs');
fs.writeFile(filename, jsonData, function(err) {
    if (err) {
        console.log(err);
    }
});

//cry a lot